package ru.ulstu.report.model.dto;

import ru.ulstu.file.model.FileDataDto;
import ru.ulstu.indicator.model.Indicator;
import ru.ulstu.report.model.ReportValue;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

public class ReportValueDto {
    private Integer id = 0;
    private Integer reportId;
    private Indicator indicator;
    private int indicatorValue;
    private List<FileDataDto> files = new ArrayList<>();
    private String comment;

    public ReportValueDto() {
    }

    public ReportValueDto(Integer reportId, Indicator indicator) {
        this.reportId = reportId;
        this.indicator = indicator;
    }

    public ReportValueDto(Indicator indicator) {
        this.indicator = indicator;
    }

    public ReportValueDto(ReportValue reportValue, Integer reportId) {
        this.id = reportValue.getId();
        this.reportId = reportId;
        this.indicator = reportValue.getIndicator();
        this.files = reportValue.getFiles().stream().map(FileDataDto::new).collect(Collectors.toList());
        this.indicatorValue = reportValue.getIndicatorValue();
        this.comment = reportValue.getComment();
    }

    public Indicator getIndicator() {
        return indicator;
    }

    public void setIndicator(Indicator indicator) {
        this.indicator = indicator;
    }

    public int getIndicatorValue() {
        return indicatorValue;
    }

    public void setIndicatorValue(int indicatorValue) {
        this.indicatorValue = indicatorValue;
    }

    public List<FileDataDto> getFiles() {
        return files;
    }

    public void setFiles(List<FileDataDto> files) {
        this.files = files;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getReportId() {
        return reportId;
    }

    public void setReportId(Integer reportId) {
        this.reportId = reportId;
    }

    public String getComment() {
        return comment;
    }

    public void setComment(String comment) {
        this.comment = comment;
    }
}
